import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;

public class DonneesPanel extends JPanel {
    private JTable table;
    private DefaultTableModel model;
    private int amount;

    public DonneesPanel() {
        this.init();
    }

    private void init() {
        this.effacerDonnees();

        this.table = new JTable(this.model);
        this.add(new JScrollPane(this.table));
    }

    public void ajouterColonne() {
        if (this.amount < 5) {
            this.model.addColumn("Série " + this.amount++);
        }

        System.out.println(this.amount);
    }

    public void supprimerColonne() {
        if (this.amount <= 1) {
            return;
        }

        removeColumn(this.amount--);

        System.out.println(this.amount);
    }

    public void effacerDonnees() {
        this.amount = 0;
        this.model = new DefaultTableModel(10, 0);

        this.model.addColumn("Données ");
        this.model.addColumn("Série " + ++this.amount);

        if (this.table != null) {
            this.table.setModel(this.model);
        }

        this.amount = 2;
    }

    private void removeColumn(int index) {
        int nRow = this.table.getRowCount();
        int nCol = this.table.getColumnCount() - 1;

        Object[][] cells = new Object[nRow][nCol];
        String[] names = new String[nCol];

        for (int j = 0; j < nCol; j++) {
            if (j < index) {
                names[j] = this.table.getColumnName(j);
                for (int i = 0; i < nRow; i++) {
                    cells[i][j] = this.table.getValueAt(i, j);
                }
            } else {
                names[j] = this.table.getColumnName(j + 1);
                for (int i = 0; i < nRow; i++) {
                    cells[i][j] = this.table.getValueAt(i, j + 1);
                }
            }
        }

        this.model = new DefaultTableModel(cells, names);
        this.table.setModel(this.model);
    }
}